/**
 * Move Eye. 
 * by Simon Greenwold.
 * 
 * The camera lifts up (controlled by mouseY) while looking at the same point.
 */
 
 
import processing.serial.*;

int NUNCHUCK_SIZE = 7;

Serial port;                         // The serial port
int[] serialInArray = new int[NUNCHUCK_SIZE];    // Where we'll put what we receive
int serialCount = 0;                 // A count of how many bytes we receive
boolean firstContact = false;        // Whether we've heard from the microcontroller

int dirx, diry;
float forcex= 128, forcey=128, forcez=128;
int zbutton, cbutton;

void setup() {
  size(400, 400, P3D);
  fill(204);  

  // Print a list of the serial ports, for debugging purposes:
  println(Serial.list());
  // I know that the first port in the serial list on my mac
  // is always my  Keyspan adaptor, so I open Serial.list()[0].
  // On Windows machines, this generally opens COM1.
  // Open whatever port is the one you're using.
  port = new Serial(this, Serial.list()[0], 9600*2);
  
  
}

float midx = 128;
float midy=128;
float midz=128;
float middirx=128;
float middiry=128;
float zoom = 50, distance = 200;
float angX, angY;

float myAngle = 0,myX = 0, myY = 0, myZ = 500;

void draw() {
  while (port.available() > 0) {
    serialEvent(port.read());
  }
  
  angX = (dirx-middirx)*-0.01;
  angY = (diry-middiry)*0.01;
  
  myX = (forcex-128.0)*1;
  myY = (forcey-128.0)*1;
  myZ = (forcez-128.0)*1;
  
  
  float len;
  
  len = myX*myX+myY*myY+myZ*myZ;
  //normX = 
  
  /*
  print(midx);
  print(' ');
  print(myX);
  print(' ');
  print(myY);
  print(' ');
  print(myZ);
  println();
  // */

  lights();
  background(0);
  // Change height of the camera with mouseY
  /*
  camera(distance*cos(angY)*sin(angX), distance*sin(angY), distance*cos(angY)*cos(angX), // eyeX, eyeY, eyeZ
         0, 0 ,0, // centerX, centerY, centerZ
         0, 1, 0); // upX, upY, upZ
         //myX, -myZ, myY); // upX, upY, upZ
  //*/  
  camera(myX, myY, myZ, // eyeX, eyeY, eyeZ
  //camera(myZ, myX, myY, // eyeX, eyeY, eyeZ
         0, 0 ,0, // centerX, centerY, centerZ
         0, 1, 0); // upX, upY, upZ
  noStroke();
  
    //pushMatrix();
  stroke(255, 0, 0);
  line(-100, 0, 0, 100, 0, 0);
  stroke(0, 255, 0);
  line(0, -100, 0, 0, 100, 0);
  stroke(0, 0,255);
  line(0, 0, -100, 0, 0, 100);
  
  //line(0, 0, 0, 0, myY, -myZ);
  //line(0, 0, 0, myX, myZ, myY);
  //translate(myX, myZ, myY);
  
  stroke(255);
  box(20);
  
  //popMatrix();
  
  
  if (zbutton == 0)
  {
    distance -= 1.0;
    if (distance < 10)
      distance = 370;
  }
  if (cbutton == 0)
  {
    middirx = dirx;
    middiry = dirx;
  }
  

}


void serialEvent(int inByte) 
{ 
  //println(inByte);
  if (inByte == 0xFF)
  {
    serialCount = 0;
  }
  else
  {
    // Add the latest byte from the serial port to array:
    if (serialCount < NUNCHUCK_SIZE)
      serialInArray[serialCount] = inByte;
    serialCount++;
    // If we have 3 bytes:
    if (serialCount ==  NUNCHUCK_SIZE) {
      dirx = (int)serialInArray[0];
      diry = (int)serialInArray[1];
      forcex = 0.7 * forcex + 0.3 * serialInArray[2];
      forcey =  0.7 * forcey + 0.3 * serialInArray[3];
      forcez =  0.7 * forcez + 0.3 * serialInArray[4];
      zbutton = (int)serialInArray[5];
      cbutton = (int)serialInArray[6];
      
      print(dirx);
      print(' ');
      print(diry);
      print(' ');
      print(forcex);
      print(' ');
      print(forcey);
      print(' ');
      print(forcez);
      print(' ');
      print(zbutton);
      print(' ');
      print(cbutton);
      print(' ');
      println();
      // Reset serialCount:
      serialCount = 0;
    }
  }
}

